unit utMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, FileCtrl, Grids,registry,ShellApi,Zip32, ExtCtrls;

type
  ArrayOfString = Array[1..10] of String;

  TwinMain = class(TForm)
    Label1: TLabel;
    btnDel: TButton;
    dcbDrive: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    Button2: TButton;
    Button3: TButton;
    lblPath: TLabel;
    chkSubDir: TCheckBox;
    grdType: TStringGrid;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Button4: TButton;
    SaveDialog1: TSaveDialog;
    chkDelFirst: TRadioButton;
    RadioButton2: TRadioButton;
    Bevel1: TBevel;
    grdFile: TStringGrid;
    Label2: TLabel;
    Label3: TLabel;
    procedure btnDelClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function StrInArray(Str : string) : Boolean;
    function FileInArray(Str : String) : Boolean;
    procedure DelTypeFile(ParentDirectory : string; IncludeSubdir : Boolean);
    procedure delToRecycled(FileName : String);
    //ɾջ.
  end;
//ɾParentDirectoryĿ¼Ŀ¼µfiletypeļ.
var
  winMain: TwinMain;


{ global routines }
procedure ZipFiles(FileName : string; FileList: TStrings);
procedure SetDummyInitFunctions(var Z:TZipUserFunctions);

{ dummy helper initialization functions }
function DummyPrint(Buffer: PChar; Size: ULONG): integer; stdcall ;
function DummyPassword(P: PChar; N: Integer; M, Name: PChar): integer; stdcall ;
function DummyComment(Buffer: PChar): PChar; stdcall ;
function DummyService(Buffer: PChar; Size: ULONG): integer; stdcall;


implementation

uses utResult;

var TempDir : String;

{$R *.DFM}


procedure ZipFiles(FileName : string; FileList: TStrings);
var
  i        : integer;
  ZipRec   : TZCL;
  ZUF      : TZipUserFunctions;
  FNVStart : PCharArray;
begin

  { precaution }
  if Trim(FileName) = '' then Exit;
  if FileList.Count <= 0 then Exit;

  { initialize the dll with dummy functions }
  SetDummyInitFunctions(ZUF);

  { number of files to zip }
  ZipRec.argc := FileList.Count;

  { name of zip file - allocate room for null terminated string  }
  GetMem(ZipRec.lpszZipFN, Length(FileName) + 1 );
  ZipRec.lpszZipFN := StrPCopy( ZipRec.lpszZipFN, FileName);
  try
    { dynamic array allocation }
    GetMem(ZipRec.FNV, ZipRec.argc * SizeOf(PChar));
    FNVStart := ZipRec.FNV;
    try
      { copy the file names from FileList to ZipRec.FNV dynamic array }
      for i := 0 to ZipRec.argc - 1 do
      begin
        GetMem(ZipRec.FNV^[i], Length(FileList[i]) + 1 );
        StrPCopy(ZipRec.FNV^[i], FileList[i]);
      end;
      try
        { send the data to the dll }
        ZpArchive(ZipRec);
      finally
        { release the memory for the file list }
        ZipRec.FNV := FNVStart;
        for i := (ZipRec.argc - 1) downto 0 do
          FreeMem(ZipRec.FNV^[i], Length(FileList[i]) + 1 );
      end;

    finally
      { release the memory for the ZipRec.FNV dynamic array }
      ZipRec.FNV := FNVStart;
      FreeMem(ZipRec.FNV, ZipRec.argc * SizeOf(PChar));
    end;
  finally
    { release the memory for the FileName }
    FreeMem(ZipRec.lpszZipFN, Length(FileName) + 1 );
  end;

end;

procedure SetDummyInitFunctions(var Z:TZipUserFunctions);
begin
  { prepare ZipUserFunctions structure }
  with Z do
  begin
    @Print     := @DummyPrint;
    @Comment   := @DummyComment;
    @Password  := @DummyPassword;
    @Service   := @DummyService;
  end;
  { send it to dll }
  ZpInit(Z);
end;
{----------------------------------------------------------------------------------}
function DummyPrint(Buffer: PChar; Size: ULONG): integer;
begin
//  frmMain.Memo.Lines.Add(Buffer);
  Result := Size;
end;
{----------------------------------------------------------------------------------}
function DummyPassword(P: PChar; N: Integer; M, Name: PChar): integer;
begin
  Result := 1;
end;
{----------------------------------------------------------------------------------}
function DummyComment(Buffer: PChar): PChar;
begin
  Result := Buffer;
end;
{----------------------------------------------------------------------------------}
function DummyService(Buffer: PChar; Size: ULONG): integer;
begin
//  frmMain.Memo.Lines.Add('> '+StrPas(Buffer));
  Result := 0;
end;


function TwinMain.StrInArray(Str : string ) : Boolean;
var i : Integer;
    k : Integer;
begin
  k := grdType.RowCount - 1 ;
  for i := 1 to k do
  begin
    if Str = '.' + grdType.Cells[1,i] then Break;
  end;
  if i > k then
     Result := false
  else Result := True;
end;

function TwinMain.FileInArray(Str : String) : Boolean;
var i : Integer;
    k : Integer;
begin
  k := grdFile.RowCount - 1 ;
  for i := 1 to k do
  begin
    if Str = grdFile.Cells[1,i] then Break;
  end;
  if i > k then
     Result := false
  else Result := True;
end;

function SlashSep(const Path, S: String): String;
begin
  if (Path <> '') and (AnsiLastChar(Path)^ <> '\') then
    Result := Path + '\' + S
  else
    Result := Path + S;
end;


procedure TwinMain.btnDelClick(Sender: TObject);
begin
  TempDir := GetCurrentDir;
  SetCurrentDir(lblPath.Caption);
  DelTypeFile('',chkSubDir.Checked);  //ɾļṩ  Files ļб
  if chkDelFirst.Checked then
     begin
       Application.Messagebox('ɾļ!','ʾ',0);
       SetCurrentDir(TempDir);
     end;
end;

procedure TwinMain.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TwinMain.DelTypeFile(ParentDirectory : string; IncludeSubdir : Boolean);
var
  Status: Integer;
  SearchRec: TSearchRec;
begin
  Status := FindFirst(SlashSep(ParentDirectory, '*.*'), faDirectory, SearchRec);
  try
    while Status = 0 do
    begin
      if (SearchRec.Attr and faDirectory = faDirectory) then //Ŀ¼,ҪĿ¼
      begin
        if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then
        begin
          if  IncludeSubdir  then
          DelTypeFile(SlashSep(ParentDirectory, SearchRec.Name),IncludeSubdir);
          //ڹ
        end;
      end
      else  //ļ
        begin
          if  StrInArray(ExtractFileExt(SearchRec.Name)) then //趨
              begin
                // ͼڲ,ɾ
                {if chkdelToRecycled.checked then delToRecycled(SlashSep(ParentDirectory ,SearchRec.Name))
                else}
                if chkDelFirst.Checked then //ɾ
                   begin
                      if DeleteFile(SlashSep(ParentDirectory ,SearchRec.Name)) then
                         winResult.lstDelete.Items.Add(SlashSep(ParentDirectory ,SearchRec.Name) +  '   ɾɹ')
                   end
                else  //ֻ趨͵ļ
                   begin
                      winResult.lstBackup.Items.Add(SlashSep(ParentDirectory ,SearchRec.Name)) ;
                   end;
              end
          else //趨
              begin
                if chkDelFirst.Checked then //Ҫ
                   begin
                      winResult.lstBackup.Items.Add(SlashSep(ParentDirectory ,SearchRec.Name)) ;
                   end
                else //ָļб,ҲҪ
                   begin
                      //жǲָļ
                      if FileInArray(SearchRec.Name) then
                         begin
                           winResult.lstBackup.Items.Add(SlashSep(ParentDirectory ,SearchRec.Name)) ;
                         end;
                   end;
              end;
        end;
      Status := FindNext(SearchRec);
    end;
  finally
    FindClose(SearchRec);
  end;//end of try
end;

procedure TwinMain.FormCreate(Sender: TObject);
var
    Reg            : TRegistry;
    TempS          : String;
    TempFiles      : String;
    i,j : Integer;
    SubS : String;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := HKey_Current_User;
  if Reg.OpenKey('SoftWare\sw\BackupTool',FALSE) then //ǵһ
  begin
     //ָ
      TempS  := Reg.ReadString('FileTypes');
      i := 1;
      j := 1;
      while i <= Length(TempS) do
      begin
        if TempS[i] <> ';' then
           begin
             SubS := SubS + TempS[i];
           end
        else
           begin
             grdType.Cells[1,j] := SubS;
             SubS := '';
             Inc(j);
           end;
        Inc(i);
      end;//end of while
      //ָļ
      TempFiles := Reg.ReadString('FileNames');
      i := 1;
      j := 1;
      while i <= Length(TempFiles) do
      begin
        if TempFiles[i] <> ';' then
           begin
             SubS := SubS + TempFiles[i];
           end
        else
           begin
             grdFile.Cells[1,j] := SubS;
             SubS := '';
             Inc(j);
           end;
        Inc(i);
      end;//end of while
  end
  else    //дȱʡdelphiĿļ
      begin
        grdType.Cells[1,1] := 'pas';
        grdType.Cells[1,2] := 'dfm';
        grdType.Cells[1,3] := 'dpr';
        grdType.Cells[1,4] := 'dof';
        grdType.Cells[1,5] := 'cfg';
        grdType.Cells[1,6] := 'res';
      end;
  Reg.CloseKey;
  Reg.Free;
  grdType.Cells[1,0] := 'Extension';
  grdType.Cells[0,0] := 'Order';
  for i := 1 to grdType.RowCount - 1 do
    begin
      grdType.Cells[0,i] := IntToStr(i);
    end;
  grdFile.Cells[1,0] := 'FileName';
  grdFile.Cells[0,0] := 'Order';
  for i := 1 to grdFile.RowCount - 1 do
    begin
      grdFile.Cells[0,i] := IntToStr(i);
    end;
end;

procedure TwinMain.SpeedButton1Click(Sender: TObject);
var
    Reg            : TRegistry;
    i : Integer;
    SubS : String;
    SubFile : String;
begin
  SubS := '';
  for i := 1 to grdType.RowCount - 1 do
  begin
    SubS := SubS + grdType.Cells[1,i] + ';';
  end;
  SubFile := '';
  for i := 1 to grdFile.RowCount - 1 do
  begin
    SubFile := SubFile + grdFile.Cells[1,i] + ';';
  end;
  Reg := TRegistry.Create;
  Reg.RootKey := HKey_Current_User;
  if not Reg.OpenKey('SoftWare\sw\BackupTool',FALSE) then
  begin
      Reg.OpenKey('SoftWare\sw\BackupTool',True) ;//
  end;
  Reg.WriteString('FileTypes',SubS);
  Reg.WriteString('FileNames',SubFile);
  Reg.CloseKey;
  Reg.Free;
end;

procedure TwinMain.SpeedButton2Click(Sender: TObject);
var i :  Integer;
begin
  for i := 1 to grdType.RowCount - 1 do
  begin
    grdType.Cells[1,i] := '';
  end;//end of fro
end;

procedure TwinMain.delToRecycled(FileName : String);
//function SHFileOperation(const lpFileOp: TSHFileOpStruct): Integer; stdcall;
Var T:TSHFileOpStruct;
begin
  With T do
  Begin
    Wnd:=0;
    wFunc:=FO_MOVE;
    pFrom:=Pchar(FileName);
    fFlags:=FOF_ALLOWUNDO
  End;
  SHFileOperation(T);
end;

procedure TwinMain.Button4Click(Sender: TObject);
begin
  winResult.Show;
end;

procedure TwinMain.Button2Click(Sender: TObject);
begin
  if chkDelFirst.Checked then
     if  Application.Messagebox('Ready to delete files ,Are you sure?','Warning!',MB_OKCANCEL) <> IDOK then Exit;
  SaveDialog1.InitialDir := lblPath.Caption;
  if SaveDialog1.Execute then
     begin
       winResult.lstDelete.Items.Clear;
       winresult.lstBackup.Items.Clear;
       btnDel.Click;
       //һ仰ǳҪ,·,zip32.dllͲ֪ôȥЩļ,Ҳ.Ǻ.
       //,ֻ,demoر.ֻsetcurrentdirʵ.
{       TempS := lblPath.Caption;
       TheZPOPT := ZpGetOptions;
//       TheZPOPT.szRootDir := pchar(TempS);
       if not ZpSetOptions(TheZPOPT) then showmessage('adf');     }
       ZipFiles(SaveDialog1.FileName , winResult.lstBackup.Items);
       SetCurrentDir(TempDir);
       Application.MessageBox(pchar('Backup Success! Result File:' + SaveDialog1.FileName),'Hint',0);
       winResult.lblDelete.Caption := 'Delete Files  ' + IntToStr(winResult.lstDelete.Items.Count) ;
       winResult.lblBackup.Caption := 'Backup Files  ' + IntToStr(winResult.lstBackup.Items.Count) ;
     end;
end;

end.
